﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Telerik.Windows.Diagrams.Core;
using Telerik.Windows.Controls.Diagrams.Extensions.ViewModels;

namespace MindMapWithLoadFromXML
{
    public partial class MyGraphSource
    {
        public override void SerializeNode(GraphNode node, SerializationInfo info)
        {
            base.SerializeNode(node, info);
           
            MindmapNode node2 = node as MindmapNode;
            string pom = node2.ToString();
            info["Content"] = node2.Content;
            info["ShapeType"] = node2.Type.ToString();
            info["Id"] = node2.GetID();
            info["Desc"] = node2.Desc;      
        }

        public override void SerializeLink(Link link, SerializationInfo info)
        {
            this.ClearCache();
            base.SerializeLink(link, info);
        }

        public override GraphNode DeserializeNode(IShape shape, SerializationInfo info)
        {
            MindmapNode node = new MindmapNode();

            string pom = string.Empty;
            string desc = string.Empty;
            if (info["ShapeType"] != null)
            {               
                node.Desc = (info["Desc"].ToString());
                node.Content = (info["Content"].ToString());
                node.ID = (info["Id"].ToString());
                var shapeType = (NodeType)Enum.Parse(typeof(NodeType), info["ShapeType"].ToString());
                node.Type = shapeType;
            }
            return node;
        }

        public override string GetNodeUniqueId(GraphNode node)
        {
            if (node != null)
                return node.GetHashCode().ToString();

            return string.Empty;
        }

        public override object CreateNode(IShape shape)
        {
            var newItem = base.CreateNode(shape);
            if (shape.Content != null)
                (newItem as NodeViewModelBase).Content = shape.Content;
            else
                (newItem as NodeViewModelBase).Content = "New Shape";


            return newItem;
        }
    }
}
