﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MindMapWithLoadFromXML
{
    public class MindmapNode : GraphNode
    {
        public string Name { get; set; }
        public string Desc { get; set; }

        //public string Id { get; set; }
        public NodeType Type { get; set; }

        public List<string> References { get; set; }
        public object Data { get; set; }

        public MindmapNode()
        {
            References = new List<string>();
        }

        public void FindType(string type)
        {
            switch (type)
            {
                case "text":
                    Type = NodeType.Text;
                    break;
                case "file":
                    Type = NodeType.File;
                    break;
                case "image":
                    Type = NodeType.Image;
                    break;
                case "video":
                    Type = NodeType.Video;
                    break;
                default:
                    break;
            }
        }

        public MindmapNode CreateCopy()
        {
            MindmapNode node = new MindmapNode();
            node.Name = this.Name;
            node.Desc = this.Desc;
            node.Content = this.Content;

            foreach (string reference in this.References)
            {
                node.References.Add(reference);
            }
            return node;
        }
    }

    public enum NodeType
    {
        Text,
        File,
        Image,
        Video
    }
}
